clear
load PC1156r02
Nsamples = 1000;
wsamples = linspace(0.305,0.421,Nsamples);
Pout = wsamples;
phi = 0.45;
Lstub = 1;
for kk = 2 : Nsamples-1 
w = wsamples(kk);


[bikhod, Indw] = min(abs(wvec-w));
beta0 = Linearinterp(betaPCW(Indw-1),betaPCW(Indw),wvec(Indw-1),wvec(Indw),w);
betagap = Linearinterp(Blochr02(Indw-1),Blochr02(Indw),wvec(Indw-1),wvec(Indw),w);
% Note: here we use the approximation described in the paper for
% calculating propagation constants. we also slightly modify it to have a
% better approximation although it is not crucial. This modification is 
% simply achieved by multiplying the Bloch wavenumber to a proper constant.

beta01 = Linearinterp(Blochr01(Indw-1),Blochr01(Indw),wvec(Indw-1),wvec(Indw),w)*1.015;
beta005 = Linearinterp(Blochr005(Indw-1),Blochr005(Indw),wvec(Indw-1),wvec(Indw),w)*1.007;

if abs(imag(beta01))>0.01
    beta01 = beta01/1.015;
end

Zr02kk = Linearinterp(Zr02(Indw-1),Zr02(Indw),wvec(Indw-1),wvec(Indw),w);
Zr01kk = Linearinterp(Zr01(Indw-1),Zr01(Indw),wvec(Indw-1),wvec(Indw),w);
Zr005kk = Linearinterp(Zr005(Indw-1),Zr005(Indw),wvec(Indw-1),wvec(Indw),w);

lambda = 1/w;
k0 =2*pi/lambda;

Y2 = 1/Inputimpedance(1,beta0,phi/beta0,Zr02kk);

Zin = Inputimpedance(Zr005kk,beta005,1,Zr02kk);
Zin = Inputimpedance(Zr02kk,betagap,1,Zin);
Y1 = 1/Inputimpedance(1,beta0,phi/beta0,Zin);
Ystub = Y1-Y2;

Zin = Inputimpedance(Zr01kk,beta01,1,1);
Zin = Inputimpedance(1,beta0,1.5,Zin);
Zin = 1/(1/Zin+Ystub);
Zin = Inputimpedance(1,beta0,1.5,Zin);
Zin = Inputimpedance(Zr01kk,beta01,1,Zin);

R = (Zin - 1)/(Zin + 1);
Pout(kk) = 1-abs(R)^2;
end
% figure
hold on;plot(wsamples,Pout,'k')
% axis([0.305 0.42 0 1])
